//
//  SquishController.h
//  squish
//
//  Created by Da Woon Jung on 2006-06-23.
//  Copyright 2006 Da Woon Jung. All rights reserved.
//

#import <Cocoa/Cocoa.h>

//#define USE_DDS_PREVIEW

@class SquishExportOptionsController;
@class SquishProgressController;
@class SquishDDSWindow;


@interface SquishController : NSObject
{
    IBOutlet NSPanel *helpWindow;
    SquishExportOptionsController *exportController;
    SquishProgressController *progressController;
#ifdef USE_DDS_PREVIEW
    SquishDDSWindow *ddsPreview;
#endif
    BOOL showOptions;
    BOOL didOpenFiles;
    BOOL enableGenMipmaps;
    BOOL enableAssembleMipmaps;

    CMProfileRef sysprof;
    CMProfileRef dispProf;
}

- (void)browseFilesOrFolders: (id)aSender;
- (int)showExportOptions;

- (NSApplicationDelegateReply)exportFiles: (NSArray *)aFilenames;
- (void)browseDestination: (id)aSender;
- (void)convert: (id)aSender;
- (void)abortConvert: (id)aSender;
- (void)showMyHelp: (id)aSender;

- (BOOL)enableGenMipmaps;
- (BOOL)enableAssembleMipmaps;
- (void)setEnableGenMipmaps: (BOOL)aEnable;
- (void)setEnableAssembleMipmaps: (BOOL)aEnable;
@end
