#ifndef _SQUISH_DDS_H_
#define _SQUISH_DDS_H_
/*
 *  dds.h
 *  squish
 *
 *  Created by Da Woon Jung on 6/24/06.
 *
 */

struct DDPixelFormat
{
    uint32_t size;
    uint32_t flags;
    uint32_t fourCC;
    uint32_t bpp;
    uint32_t redMask;
    uint32_t greenMask;
    uint32_t blueMask;
    uint32_t alphaMask;
};

struct DDSCaps
{
    uint32_t caps;
    uint32_t caps2;
    uint32_t caps3;
    uint32_t caps4;
};

struct DDColorKey
{
    uint32_t lowVal;
    uint32_t highVal;
};

struct DDSurfaceDesc
{
    uint32_t size;
    uint32_t flags;
    uint32_t height;
    uint32_t width;
    uint32_t pitch;
    uint32_t depth;
    uint32_t mipMapLevels;
    uint32_t alphaBitDepth;
    uint32_t reserved;
    uint32_t surface;
    
    DDColorKey ckDestOverlay;
    DDColorKey ckDestBlt;
    DDColorKey ckSrcOverlay;
    DDColorKey ckSrcBlt;
    
    DDPixelFormat format;
    DDSCaps caps;
    
    uint32_t textureStage;
};


uint32_t FourCC(const char* s)
{
    return (((uint32_t) s[3] << 24) |
            ((uint32_t) s[2] << 16) |
            ((uint32_t) s[1] << 8) |
            (uint32_t) s[0]);
}


#define DDSD_CAPS	0x00000001
#define DDSD_HEIGHT	0x00000002
#define DDSD_WIDTH	0x00000004
#define DDSD_PITCH	0x00000008
#define DDSD_PIXELFORMAT	0x00001000
#define DDSD_MIPMAPCOUNT	0x00020000
#define DDSD_LINEARSIZE	0x00080000
#define DDSD_DEPTH	0x00800000

#define DDPF_RGB    0x40
#define DDPF_FOURCC 0x04

#define DDSCAPS_COMPLEX	0x00000008
#define DDSCAPS_TEXTURE	0x00001000
#define DDSCAPS_MIPMAP	0x00400000

#endif _SQUISH_DDS_H_
